## rehex 0.3.1

=== Makefile ===
# Reverse Engineer's Hex Editor
# Copyright (C) 2017-2020 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

WX_CONFIG ?= wx-config

EXE ?= rehex
EMBED_EXE ?= ./tools/embed

# Wrapper around the $(shell) function that aborts the build if the command
# exits with a nonzero status.
shell-or-die = $\
	$(eval sod_out := $(shell $(1); echo $$?))$\
	$(if $(filter 0,$(lastword $(sod_out))),$\
		$(wordlist 1, $(shell echo $$(($(words $(sod_out)) - 1))), $(sod_out)),$\
		$(error $(1) exited with status $(lastword $(sod_out))))

WX_CXXFLAGS := $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv)
WX_LIBS     := $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv)

CFLAGS   := -Wall -std=c99   -ggdb -I. -Iinclude/ $(CFLAGS)
CXXFLAGS := -Wall -std=c++11 -ggdb -I. -Iinclude/ $(WX_CXXFLAGS) $(CXXFLAGS)

LDLIBS := $(WX_LIBS) -ljansson -lcapstone $(LDLIBS)

ifeq ($(DEBUG),)
	DEBUG=0
endif

ifeq ($(DEBUG),0)
	CFLAGS   += -DNDEBUG
	CXXFLAGS += -DNDEBUG
else
	CFLAGS   += -g
	CXXFLAGS += -g
endif

# Define this for releases
VERSION := 0.3.1

# NOTE: Not evaluated when building from dist
GIT_COMMIT_SHA  ?= $(call shell-or-die,git log -1 --format="%H")
GIT_COMMIT_TIME  = $(call shell-or-die,git log -1 --format="%ct")

ifdef VERSION
	LONG_VERSION := Version $(VERSION)
else
	VERSION      := 69a1baec92dee55ee60aa0e8b2b3f910546ad508
	LONG_VERSION := Snapshot 69a1baec92dee55ee60aa0e8b2b3f910546ad508
endif

DEPDIR := .d
$(shell mkdir -p $(DEPDIR)/res/ $(DEPDIR)/src/ $(DEPDIR)/tools/ $(DEPDIR)/tests/ $(DEPDIR)/googletest/src/)
DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$@.Td
DEPPOST = @mv -f $(DEPDIR)/$@.Td $(DEPDIR)/$@.d && touch $@

.PHONY: all
all: $(EXE)

.PHONY: check
check: tests/all-tests
	./tests/all-tests

.PHONY: clean
clean:
	rm -f res/ascii16.c   res/ascii16.h \
	      res/ascii24.c   res/ascii24.h \
	      res/ascii32.c   res/ascii32.h \
	      res/ascii48.c   res/ascii48.h \
	      res/icon16.c    res/icon16.h \
	      res/icon32.c    res/icon32.h \
	      res/icon48.c    res/icon48.h \
	      res/icon64.c    res/icon64.h \
	      res/icon128.c   res/icon128.h \
	      res/license.c   res/license.h \
	      res/offsets16.c res/offsets16.h \
	      res/offsets24.c res/offsets24.h \
	      res/offsets32.c res/offsets32.h \
	      res/offsets48.c res/offsets48.h
	
	rm -f $(APP_OBJS)
	rm -f $(EXE)
	rm -f $(TEST_OBJS)
	rm -f ./tests/all-tests
	rm -f $(EMBED_EXE)

.PHONY: distclean
distclean: clean

APP_OBJS := \
	res/ascii16.o \
	res/ascii24.o \
	res/ascii32.o \
	res/ascii48.o \
	res/icon16.o \
	res/icon32.o \
	res/icon48.o \
	res/icon64.o \
	res/icon128.o \
	res/license.o \
	res/offsets16.o \
	res/offsets24.o \
	res/offsets32.o \
	res/offsets48.o \
	src/AboutDialog.o \
	src/app.o \
	src/ArtProvider.o \
	src/BasicDataTypes.o \
	src/buffer.o \
	src/BytesPerLineDialog.o \
	src/ByteRangeSet.o \
	src/ClickText.o \
	src/CodeCtrl.o \
	src/CommentTree.o \
	src/DataType.o \
	src/decodepanel.o \
	src/DiffWindow.o \
	src/disassemble.o \
	src/document.o \
	src/DocumentCtrl.o \
	src/EditCommentDialog.o \
	src/Events.o \
	src/FillRangeDialog.o \
	src/LicenseDialog.o \
	src/mainwindow.o \
	src/Palette.o \
	src/search.o \
	src/SelectRangeDialog.o \
	src/StringPanel.o \
	src/textentrydialog.o \
	src/Tab.o \
	src/ToolPanel.o \
	src/util.o \
	src/win32lib.o \
	$(EXTRA_APP_OBJS)

$(EXE): $(APP_OBJS)
	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -c -o res/version.o res/version.cpp
	$(CXX) $(CXXFLAGS) -o $@ $^ res/version.o $(LDFLAGS) $(LDLIBS)

TEST_OBJS := \
	googletest/src/gtest-all.o \
	res/ascii16.o \
	res/ascii24.o \
	res/ascii32.o \
	res/ascii48.o \
	res/icon16.o \
	res/icon32.o \
	res/icon48.o \
	res/icon64.o \
	res/offsets16.o \
	res/offsets24.o \
	res/offsets32.o \
	res/offsets48.o \
	src/ArtProvider.o \
	src/BasicDataTypes.o \
	src/buffer.o \
	src/ByteRangeSet.o \
	src/CommentTree.o \
	src/DataType.o \
	src/DiffWindow.o \
	src/document.o \
	src/DocumentCtrl.o \
	src/EditCommentDialog.o \
	src/Events.o \
	src/Palette.o \
	src/search.o \
	src/StringPanel.o \
	src/Tab.o \
	src/textentrydialog.o \
	src/ToolPanel.o \
	src/util.o \
	src/win32lib.o \
	tests/buffer.o \
	tests/ByteRangeMap.o \
	tests/ByteRangeSet.o \
	tests/CommentsDataObject.o \
	tests/CommentTree.o \
	tests/DiffWindow.o \
	tests/Document.o \
	tests/DocumentCtrl.o \
	tests/main.o \
	tests/NestedOffsetLengthMap.o \
	tests/NumericTextCtrl.o \
	tests/search-bseq.o \
	tests/search-text.o \
	tests/SearchValue.o \
	tests/SafeWindowPointer.o \
	tests/SharedDocumentPointer.o \
	tests/StringPanel.o \
	tests/Tab.o \
	tests/util.o

tests/all-tests: $(TEST_OBJS)
	$(CXX) $(CXXFLAGS) -o $@ $^ $(LDFLAGS) $(LDLIBS)

$(EMBED_EXE): tools/embed.cpp
	$(CXX) $(CXXFLAGS) -o $@ $<

src/AboutDialog.o: res/icon128.h
src/ArtProvider.o: res/ascii16.h res/ascii24.h res/ascii32.h res/ascii48.h res/offsets16.h res/offsets24.h res/offsets32.h res/offsets48.h
src/DiffWindow.o: res/icon16.h res/icon32.h res/icon48.h res/icon64.h
src/LicenseDialog.o: res/license.h
src/mainwindow.o: res/icon16.h res/icon32.h res/icon48.h res/icon64.h

res/license.c res/license.h: LICENSE.txt $(EMBED_EXE)
	$(EMBED_EXE) $< LICENSE_TXT res/license.c res/license.h

res/%.c res/%.h: res/%.png $(EMBED_EXE)
	$(EMBED_EXE) $< $*_png res/$*.c res/$*.h

%.o: %.c
	$(CC) $(CFLAGS) $(DEPFLAGS) -c -o $@ $<
	$(DEPPOST)

tests/%.o: tests/%.cpp
	$(CXX) $(CXXFLAGS) -I./googletest/include/ $(DEPFLAGS) -c -o $@ $<
	$(DEPPOST)

googletest/src/%.o: googletest/src/%.cc
	$(CXX) $(CXXFLAGS) -I./googletest/include/ -I./googletest/ $(DEPFLAGS) -c -o $@ $<
	$(DEPPOST)

%.o: %.cpp
	$(CXX) $(CXXFLAGS) $(DEPFLAGS) -c -o $@ $<
	$(DEPPOST)

include $(shell find .d/ -name '*.d' -type f)

prefix      ?= /usr/local
exec_prefix ?= $(prefix)
bindir      ?= $(exec_prefix)/bin
datarootdir ?= $(prefix)/share

.PHONY: install
install: $(EXE)
	install -D -m 0755 $(EXE) $(DESTDIR)$(bindir)/$(EXE)
	
	for s in 16 32 48 64 128 256 512; \
	do \
		install -D -m 0644 res/icon$${s}.png $(DESTDIR)$(datarootdir)/icons/hicolor/$${s}x$${s}/apps/rehex.png; \
	done
	
	install -D -m 0644 res/rehex.desktop $(DESTDIR)$(datarootdir)/applications/rehex.desktop

.PHONY: uninstall
uninstall:
	rm -f $(DESTDIR)$(bindir)/$(EXE)
	rm -f $(DESTDIR)$(datarootdir)/applications/rehex.desktop
	
	for s in 16 32 48 64 128 256 512; \
	do \
		rm -f $(DESTDIR)$(datarootdir)/icons/hicolor/$${s}x$${s}/apps/rehex.png; \
	done

.PHONY: dist
dist:
	rm -rf rehex-$(VERSION) rehex-$(VERSION).tar
	mkdir rehex-$(VERSION)/
	
ifneq ("$(wildcard MANIFEST)","")
	# Running from a dist tarball, ship anything in the MANIFEST
	xargs cp --parents -t rehex-$(VERSION)/ < MANIFEST
else
	# Running from the git tree, ship any checked in files
	(git ls-files && echo MANIFEST) | LC_ALL=C sort > rehex-$(VERSION)/MANIFEST
	git ls-files | xargs cp --parents -t rehex-$(VERSION)/
	
	# Inline any references to the HEAD commit sha/timestamp
	sed -i -e "s|\$69a1baec92dee55ee60aa0e8b2b3f910546ad508|69a1baec92dee55ee60aa0e8b2b3f910546ad508|g" rehex-$(VERSION)/Makefile
	sed -i -e "s|\$1605305577|1605305577|g" rehex-$(VERSION)/Makefile
endif
	
	# Generate reproducible tarball. All files use git commit timestamp.
	find rehex-$(VERSION) -print0 | \
		LC_ALL=C sort -z | \
		tar \
			--format=ustar \
			--mtime=@1605305577 \
			--owner=0 --group=0 --numeric-owner \
			--no-recursion --null  -T - \
			-cf - | \
		gzip -9n - > rehex-$(VERSION).tar.gz

=== debian/changelog ===
rehex (0.3.1-0~ubuntu1604) xenial; urgency=low

  * Correctly display signed 16-bit values in "Decode values" panel.

  * Fix status bar offset going out of sync.

  * Move cursor when a row in the "Comments" panel is double clicked.

  * Focus document after updating position/selection via "Comments" panel.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 13 Nov 2020 22:28:46 +0000

rehex (0.3.0-0~ubuntu1604) xenial; urgency=low

  * [Mark Jansen] Use byte grouping setting from main window in diff window.

  * [Mark Jansen] Use Capstone disassembler rather than LLVM.

  * [Mark Jansen] Support disassembling 16-bit x86 machine code.

  * [Mark Jansen] Don't update tools which aren't visible.

  * [Vincent Bermel] Unhardcode linux launcher icon file type.

  * Fix an uncommon use-after-free crash when closing tabs in diff window.

  * Support for disassembling 6800/68000 and MOS6502 instruction sets
    (requires recent Capstone version).

  * [Mark Jansen] Close document when tab is clicked with middle mouse button.

  * [Mark Jansen] Don't create .rehex-meta files when there is nothing to save.

  * Implement Strings tool to find and list ASCII strings in the file.

  * Add option to calculate automatic bytes per line in whole byte groups.

  * Add "Fill range" tool for overwriting ranges of bytes with a pattern.

  * Preserve column alignment after comments.

  * [Mark Jansen] Mark a document dirty if highlighting is changed.

  * Add data type annotations.

  * Show ranges marked as integers in their decoded form in the hex view.

  * Performance improvements for documents with large numbers of comments.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 10 Nov 2020 13:16:11 +0000

rehex (0.2.0-0~ubuntu1604) xenial; urgency=low

  * Allow copying comments from a document and pasting them elsewhere in the
    same document or into another one.

  * Fixed bounds check when clicking on nested comments in a document.

  * Added context menu when right clicking on a comment in a document.

  * Optionally highlight byte sequences which match the current selection.
    ("Highlight data matching selection" or "PatternMatchHighlight").

  * Allow copying cursor offset from document context menu.

  * Correctly display offsets over 4GiB in the status bar.

  * Display offsets as XXXX:XXXX rather than XXXXXXXX:XXXXXXXX when the file
    size is under 4GiB.

  * Add per-document option for dec/hex offset display.

  * When first byte after a comment is deleted, show that the comment was
    deleted rather than leaving phantom comment on screen until regions are
    repopulated.

  * Add side-by-side comparison of chunks of data from files. Select data and
    choose "Compare..." from context menu to open diff window.

  * Clean up search threads when a tab is closed while a search is running.

  * Display bytes which have been modified since the file was saved in red.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 02 Jun 2020 18:11:54 +0100

rehex (0.1.0-0~ubuntu1604) UNRELEASED; urgency=low

  * Initial release

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Thu, 12 Mar 2020 20:08:30 +0000

=== debian/control ===
Source: rehex
Priority: extra
Maintainer: Daniel Collins <solemnwarning@solemnwarning.net>
Build-Depends:
 libcapstone-dev,
 debhelper (>= 9),
 libjansson-dev,
 libwxgtk3.0-dev,
 xauth,
 xvfb,
 wx3.0-headers,
 zlib1g-dev
Standards-Version: 3.9.4
Section: editors
Homepage: https://github.com/solemnwarning/rehex/

Package: rehex
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcapstone3,
 libjansson4,
 libwxgtk3.0-0v5,
 zlib1g
Description: Reverse Engineers' Hex Editor

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export prefix := /usr

# Snapshot builds are performed using source packages generated by git-buildpackage, which lack
# the .git/ directory. The Buildkite job does a changelog bump using the Git commit SHA, which we
# must then pull back out and stick in the environment for the Makefile.
#
# This hack is better or worse than maintaining upstream tar in the Git repo and import-orig'ing
# the result of 'make dist' before kicking off the snapshot build, depending on your point of view.

GIT_COMMIT_SHA = $(shell dpkg-parsechangelog --show-field Version | grep + | cut -d+ -f2 | cut -d- -f1)
ifneq ($(GIT_COMMIT_SHA),)
	export GIT_COMMIT_SHA
endif

%:
	dh $@

override_dh_auto_test:
	xvfb-run -a -e /dev/stdout make check

## rehex 0.3.91

=== Makefile ===
# Reverse Engineer's Hex Editor
# Copyright (C) 2017-2021 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

LUA          ?= lua
WX_CONFIG    ?= wx-config
CAPSTONE_PKG ?= capstone
JANSSON_PKG  ?= jansson
LUA_PKG      ?= $(shell pkg-config --exists lua5.3 && echo lua5.3 || echo lua)

EXE ?= rehex
EMBED_EXE ?= ./tools/embed

# Wrapper around the $(shell) function that aborts the build if the command
# exits with a nonzero status.
shell-or-die = $\
	$(eval sod_out := $$(shell $(1); echo $$$$?))$\
	$(if $(filter 0,$(lastword $(sod_out))),$\
		$(wordlist 1, $(shell echo $$(($(words $(sod_out)) - 1))), $(sod_out)),$\
		$(error $(1) exited with status $(lastword $(sod_out))))

WX_CXXFLAGS ?= $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv)
WX_LIBS     ?= $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv)

CAPSTONE_CFLAGS ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --cflags)
CAPSTONE_LIBS   ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --libs)

JANSSON_CFLAGS ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --cflags)
JANSSON_LIBS   ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --libs)

LUA_CFLAGS ?= $(call shell-or-die,pkg-config $(LUA_PKG) --cflags)
LUA_LIBS   ?= $(call shell-or-die,pkg-config $(LUA_PKG) --libs)

CFLAGS   := -Wall -std=c99   -ggdb -I. -Iinclude/ -IwxLua/modules/ $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
CXXFLAGS := -Wall -std=c++11 -ggdb -I. -Iinclude/ -IwxLua/modules/ $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)

LDLIBS := $(WX_LIBS) $(CAPSTONE_LIBS) $(JANSSON_LIBS) $(LUA_LIBS) $(LDLIBS)

ifeq ($(DEBUG),)
	DEBUG=0
endif

ifeq ($(DEBUG),0)
	CFLAGS   += -DNDEBUG
	CXXFLAGS += -DNDEBUG
else
	CFLAGS   += -g
	CXXFLAGS += -g
endif

# Define this for releases
VERSION := 0.3.91

ifdef VERSION
	LONG_VERSION := Version $(VERSION)
else
	# Check if we are actually in a git checkout before trying to get the
	# commit hash with `git log`, else we blow up in a git-archive export.
	
	ifneq ($(wildcard .git/*),)
		GIT_COMMIT_SHA ?= $(call shell-or-die,git log -1 --format="%H")
	else
		GIT_COMMIT_SHA ?= UNKNOWN
	endif
	
	GIT_COMMIT_TIME ?= $(call shell-or-die,git log -1 --format="%ct")
	
	VERSION      := 37fc16444e8e2ec9c624ea288f36c75acf951465
	LONG_VERSION := Snapshot 37fc16444e8e2ec9c624ea288f36c75acf951465
endif

DEPDIR := .d
DEPPRE = @mkdir -p "$(dir $(DEPDIR)/$@.Td)"
DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$@.Td
DEPPOST = @mv -f $(DEPDIR)/$@.Td $(DEPDIR)/$@.d && touch $@

WXLUA_BINDINGS := wxLua/bindings/.done

.PHONY: all
all: $(EXE)

# Stop Make from deleting intermediate files at-will. Some intermediates (e.g. resources) are used
# by multiple targets (all and test) and so they should persist. Others are generated as a
# side-effect of another target (wxLua bindings) so Make cannot properly track how to build them
# when it needs to recreate them later.
.SECONDARY:

.PHONY: check
check: tests/all-tests
	./tests/all-tests

.PHONY: clean
clean:
	rm -f res/ascii16.c   res/ascii16.h \
	      res/ascii24.c   res/ascii24.h \
	      res/ascii32.c   res/ascii32.h \
	      res/ascii48.c   res/ascii48.h \
	      res/icon16.c    res/icon16.h \
	      res/icon32.c    res/icon32.h \
	      res/icon48.c    res/icon48.h \
	      res/icon64.c    res/icon64.h \
	      res/icon128.c   res/icon128.h \
	      res/license.c   res/license.h \
	      res/offsets16.c res/offsets16.h \
	      res/offsets24.c res/offsets24.h \
	      res/offsets32.c res/offsets32.h \
	      res/offsets48.c res/offsets48.h
	
	rm -f $(APP_OBJS)
	rm -f $(EXE)
	rm -f $(TEST_OBJS)
	rm -f ./tests/all-tests
	rm -f $(EMBED_EXE)
	
	grep -r "generated by genwxbind.lua" wxLua/ --exclude=genwxbind.lua | cut -d: -f1 | sort | uniq | xargs -r rm
	rm -f $(WXLUA_BINDINGS)

.PHONY: distclean
distclean: clean

WXLUA_OBJS := \
	wxLua/modules/wxlua/bit.o \
	wxLua/modules/wxlua/lbitlib.o \
	wxLua/modules/wxlua/wxlbind.o \
	wxLua/modules/wxlua/wxlcallb.o \
	wxLua/modules/wxlua/wxllua.o \
	wxLua/modules/wxlua/wxlobject.o \
	wxLua/modules/wxlua/wxlstate.o \
	wxLua/modules/wxlua/wxlua_bind.o

WXBIND_OBJS := \
	wxLua/modules/wxbind/src/wxadv_bind.o \
	wxLua/modules/wxbind/src/wxadv_wxladv.o \
	wxLua/modules/wxbind/src/wxaui_bind.o \
	wxLua/modules/wxbind/src/wxbase_base.o \
	wxLua/modules/wxbind/src/wxbase_bind.o \
	wxLua/modules/wxbind/src/wxbase_config.o \
	wxLua/modules/wxbind/src/wxbase_data.o \
	wxLua/modules/wxbind/src/wxbase_datetime.o \
	wxLua/modules/wxbind/src/wxbase_file.o \
	wxLua/modules/wxbind/src/wxcore_appframe.o \
	wxLua/modules/wxbind/src/wxcore_bind.o \
	wxLua/modules/wxbind/src/wxcore_clipdrag.o \
	wxLua/modules/wxbind/src/wxcore_controls.o \
	wxLua/modules/wxbind/src/wxcore_core.o \
	wxLua/modules/wxbind/src/wxcore_defsutils.o \
	wxLua/modules/wxbind/src/wxcore_dialogs.o \
	wxLua/modules/wxbind/src/wxcore_event.o \
	wxLua/modules/wxbind/src/wxcore_gdi.o \
	wxLua/modules/wxbind/src/wxcore_geometry.o \
	wxLua/modules/wxbind/src/wxcore_graphics.o \
	wxLua/modules/wxbind/src/wxcore_help.o \
	wxLua/modules/wxbind/src/wxcore_image.o \
	wxLua/modules/wxbind/src/wxcore_mdi.o \
	wxLua/modules/wxbind/src/wxcore_menutool.o \
	wxLua/modules/wxbind/src/wxcore_picker.o \
	wxLua/modules/wxbind/src/wxcore_print.o \
	wxLua/modules/wxbind/src/wxcore_sizer.o \
	wxLua/modules/wxbind/src/wxcore_windows.o \
	wxLua/modules/wxbind/src/wxcore_wxlcore.o \
	wxLua/modules/wxbind/src/wxpropgrid_bind.o

APP_OBJS := \
	res/ascii16.o \
	res/ascii24.o \
	res/ascii32.o \
	res/ascii48.o \
	res/icon16.o \
	res/icon32.o \
	res/icon48.o \
	res/icon64.o \
	res/icon128.o \
	res/license.o \
	res/offsets16.o \
	res/offsets24.o \
	res/offsets32.o \
	res/offsets48.o \
	src/AboutDialog.o \
	src/AppMain.o \
	src/AppTestable.o \
	src/ArtProvider.o \
	src/BasicDataTypes.o \
	src/buffer.o \
	src/BytesPerLineDialog.o \
	src/ByteRangeSet.o \
	src/ClickText.o \
	src/CodeCtrl.o \
	src/CommentTree.o \
	src/ConsoleBuffer.o \
	src/ConsolePanel.o \
	src/DataType.o \
	src/decodepanel.o \
	src/DiffWindow.o \
	src/disassemble.o \
	src/DisassemblyRegion.o \
	src/document.o \
	src/DocumentCtrl.o \
	src/EditCommentDialog.o \
	src/Events.o \
	src/FillRangeDialog.o \
	src/LicenseDialog.o \
	src/lua-bindings/rehex_bind.o \
	src/lua-plugin-preload.o \
	src/LuaPluginLoader.o \
	src/mainwindow.o \
	src/Palette.o \
	src/search.o \
	src/SelectRangeDialog.o \
	src/StringPanel.o \
	src/textentrydialog.o \
	src/Tab.o \
	src/ToolPanel.o \
	src/util.o \
	src/VirtualMappingDialog.o \
	src/VirtualMappingList.o \
	src/win32lib.o \
	$(WXLUA_OBJS) \
	$(WXBIND_OBJS) \
	$(EXTRA_APP_OBJS)

$(EXE): $(APP_OBJS)
	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -c -o res/version.o res/version.cpp
	$(CXX) $(CXXFLAGS) -o $@ $^ res/version.o $(LDFLAGS) $(LDLIBS)

TEST_OBJS := \
	googletest/src/gtest-all.o \
	res/ascii16.o \
	res/ascii24.o \
	res/ascii32.o \
	res/ascii48.o \
	res/icon16.o \
	res/icon32.o \
	res/icon48.o \
	res/icon64.o \
	res/icon128.o \
	res/license.o \
	res/offsets16.o \
	res/offsets24.o \
	res/offsets32.o \
	res/offsets48.o \
	src/AboutDialog.o \
	src/AppTestable.o \
	src/ArtProvider.o \
	src/BasicDataTypes.o \
	src/buffer.o \
	src/ByteRangeSet.o \
	src/BytesPerLineDialog.o \
	src/ClickText.o \
	src/CommentTree.o \
	src/ConsoleBuffer.o \
	src/DataType.o \
	src/DiffWindow.o \
	src/DisassemblyRegion.o \
	src/document.o \
	src/DocumentCtrl.o \
	src/EditCommentDialog.o \
	src/Events.o \
	src/FillRangeDialog.o \
	src/LicenseDialog.o \
	src/lua-bindings/rehex_bind.o \
	src/lua-plugin-preload.o \
	src/LuaPluginLoader.o \
	src/mainwindow.o \
	src/Palette.o \
	src/search.o \
	src/SelectRangeDialog.o \
	src/StringPanel.o \
	src/Tab.o \
	src/textentrydialog.o \
	src/ToolPanel.o \
	src/util.o \
	src/VirtualMappingDialog.o \
	src/win32lib.o \
	tests/buffer.o \
	tests/ByteRangeMap.o \
	tests/ByteRangeSet.o \
	tests/CommentsDataObject.o \
	tests/CommentTree.o \
	tests/ConsoleBuffer.o \
	tests/DiffWindow.o \
	tests/DisassemblyRegion.o \
	tests/Document.o \
	tests/DocumentCtrl.o \
	tests/LuaPluginLoader.o \
	tests/main.o \
	tests/NestedOffsetLengthMap.o \
	tests/NumericTextCtrl.o \
	tests/search-bseq.o \
	tests/search-text.o \
	tests/SearchValue.o \
	tests/SafeWindowPointer.o \
	tests/SharedDocumentPointer.o \
	tests/StringPanel.o \
	tests/Tab.o \
	tests/util.o \
	$(WXLUA_OBJS) \
	$(WXBIND_OBJS) \
	$(EXTRA_TEST_OBJS)

tests/all-tests: $(TEST_OBJS)
	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -c -o res/version.o res/version.cpp
	$(CXX) $(CXXFLAGS) -o $@ $^ res/version.o $(LDFLAGS) $(LDLIBS)

$(EMBED_EXE): tools/embed.cpp
	$(CXX) $(CXXFLAGS) -o $@ $<

src/AboutDialog.o: res/icon128.h
src/ArtProvider.o: res/ascii16.h res/ascii24.h res/ascii32.h res/ascii48.h res/offsets16.h res/offsets24.h res/offsets32.h res/offsets48.h
src/DiffWindow.o: res/icon16.h res/icon32.h res/icon48.h res/icon64.h
src/LicenseDialog.o: res/license.h
src/LuaPluginLoader.o: src/lua-bindings/rehex_bind.h src/lua-plugin-preload.h
src/mainwindow.o: res/icon16.h res/icon32.h res/icon48.h res/icon64.h

res/license.c res/license.h: LICENSE.txt $(EMBED_EXE)
	$(EMBED_EXE) $< LICENSE_TXT res/license.c res/license.h

res/%.c res/%.h: res/%.png $(EMBED_EXE)
	$(EMBED_EXE) $< $*_png res/$*.c res/$*.h

src/lua-bindings/rehex_bind.cpp src/lua-bindings/rehex_bind.h: src/lua-bindings/rehex.i src/lua-bindings/rehex_override.hpp src/lua-bindings/rehex_rules.lua $(WXLUA_BINDINGS)
	$(LUA) -e"rulesFilename=\"src/lua-bindings/rehex_rules.lua\"" wxLua/bindings/genwxbind.lua
	
	# genwxbind.lua may not modify individual files if they are already up to date.
	touch -c src/lua-bindings/rehex_bind.cpp
	touch -c src/lua-bindings/rehex_bind.h

$(WXLUA_BINDINGS):
	$(MAKE) -C wxLua/bindings/ wxadv wxaui wxbase wxcore wxlua wxpropgrid LUA=$(LUA)
	touch $@

src/lua-plugin-preload.c src/lua-plugin-preload.h: src/lua-plugin-preload.lua $(EMBED_EXE)
	$(EMBED_EXE) $< LUA_PLUGIN_PRELOAD src/lua-plugin-preload.c src/lua-plugin-preload.h

%.o: %.c $(WXLUA_BINDINGS)
	$(DEPPRE)
	$(CC) $(CFLAGS) $(DEPFLAGS) -c -o $@ $<
	$(DEPPOST)

tests/%.o: tests/%.cpp $(WXLUA_BINDINGS)
	$(DEPPRE)
	$(CXX) $(CXXFLAGS) -I./googletest/include/ $(DEPFLAGS) -c -o $@ $<
	$(DEPPOST)

googletest/src/%.o: googletest/src/%.cc
	$(DEPPRE)
	$(CXX) $(CXXFLAGS) -I./googletest/include/ -I./googletest/ $(DEPFLAGS) -c -o $@ $<
	$(DEPPOST)

%.o: %.cpp $(WXLUA_BINDINGS)
	$(DEPPRE)
	$(CXX) $(CXXFLAGS) $(DEPFLAGS) -c -o $@ $<
	$(DEPPOST)

wxLua/%.cpp: $(WXLUA_BINDINGS)
	@true

include $(shell test -d .d/ && find .d/ -name '*.d' -type f)

prefix      ?= /usr/local
exec_prefix ?= $(prefix)
bindir      ?= $(exec_prefix)/bin
datarootdir ?= $(prefix)/share
libdir      ?= $(exec_prefix)/lib

PLUGINS_INSTALL := \
	exe/bitops52.lua \
	exe/class.lua \
	exe/document_stream.lua \
	exe/enum.lua \
	exe/kaitaistruct.lua \
	exe/microsoft_pe.lua \
	exe/plugin.lua \
	exe/string_decode.lua \
	exe/string_stream.lua \
	exe/utils.lua

.PHONY: install
install: $(EXE)
	install -D -m 0755 $(EXE) $(DESTDIR)$(bindir)/$(EXE)
	
	for s in 16 32 48 64 128 256 512; \
	do \
		install -D -m 0644 res/icon$${s}.png $(DESTDIR)$(datarootdir)/icons/hicolor/$${s}x$${s}/apps/rehex.png; \
	done
	
	install -D -m 0644 res/rehex.desktop $(DESTDIR)$(datarootdir)/applications/rehex.desktop
	
	for f in $(PLUGINS_INSTALL); \
	do \

=== wxLua/bindings/CMakeLists.txt ===
# ---------------------------------------------------------------------------
# wxLua CMake bindings build file
# ---------------------------------------------------------------------------

# ---------------------------------------------------------------------------
# Project name, sets ${wxLua_SOURCE_DIR} and ${wxLua_BINARY_DIR}

project( wxLua_bindings )

# ===========================================================================
# General settings for CMake
# ===========================================================================

# ---------------------------------------------------------------------------
# Use a minimum version of CMake of 2.8, >= 2.8.3 is prefered

cmake_minimum_required( VERSION 2.8 )

# ---------------------------------------------------------------------------
# Setup the CMake environment

include( ../build/CMakewxAppLib.cmake )
include( ../build/CMakeFunctions.cmake )

# ----------------------------------------------------------------------------
# FUNCTION_ARG_PARSER( 
#       variable_name_prefix   # name to prefix variable names with
#       "FILES;DIR;PROPERTIES" # keywords to search for
#       ${ARGN} )              # separated input args 
# Usage : 
#   FUNCTION_ARG_PARSER( ABC "FILES;DIR;PROPS" FILES "a.txt" "b.txt" PROPS BBB blah )
#   Creates these local variables :
#       ABC_FILES_SET = TRUE; ABC_FILES_VALUE = "a.txt;b.txt"
#       ABC_DIR_SET   =     ; ABC_DIR_VALUE   = 
#       ABC_PROPS_SET = TRUE; ABC_PROPS_VALUE = "BBB;blah"
# ----------------------------------------------------------------------------

macro(FUNCTION_ARG_PARSER function_name arg_names )

    SET( ${function_name}_${arg}_SET )
    SET( ${function_name}_${arg}_VALUE )
    SET( arg_name_ "" )

    FOREACH(arg_ ${ARGN})
        set(a_ "")
        #string(FIND "${arg_names}" "${arg_}" a_) # simple find, no regexp
        list(FIND "${arg_names}" "${arg_}" a_) # simple find, no regexp

        if ( ${a_} GREATER -1 )
            SET( arg_name_ "${arg_}" ) # now handling this arg_name
            SET( ${function_name}_${arg_name_}_SET TRUE )
        else()
            SET( ${function_name}_${arg_name_}_VALUE "${${function_name}_${arg_name_}_VALUE}" "${arg_}" )
        endif()        
    ENDFOREACH()

    #MESSAGE("FUNCTION_ARG_PARSER ${function_name} ${arg_names} ")
    FOREACH(arg_name_ ${arg_names})
        STRING( REGEX REPLACE "^;" "" v_ "${${function_name}_${arg_name_}_VALUE}")
        SET( ${function_name}_${arg_name_}_VALUE "${v_}" )
        #MESSAGE("    ${function_name}_${arg_name_}_VALUE= ${${function_name}_${arg_name_}_VALUE}")
    ENDFOREACH()
endmacro() 


# ===========================================================================
# Regenerate the bindings
# ===========================================================================

# ---------------------------------------------------------------------------
# This CMake script can be INCLUDE()ed to add a function ADD_WXLUABIND_GENERATION
# to (re)generate the bindings files as a make target or in Visual Studio.
#
# Author : John Labenski
#
# Usage: 
#  ADD_WXLUABIND_GENERATION(target_name
#    WXLUABIND_FILES      "*_rules.lua"    # input Lua files, either "*.lua" or an explicit list "file1.lua" "file2.lua"
#    WXLUAINTERFACE_FILES "*.i"            # input interface files, either "*.i" or an explicit list "file1.i" "file2.i"
#    WORKING_DIRECTORY    "../binding_dir" # dir to run lua genwxbind.lua in.
#    PROPERTIES FOLDER    "wxLuaBindings") # optional SET_TARGET_PROPERTIES(target_name PROPERTIES ...)
#
# Note that we put dependencies on autogenerated wxLuaBind_<foo>.dummy
# files so that this target is not run for the make all target.
# You may not be able to "build" them since the dependencies exist so
# you must either "rebuild" or run "clean" first. This is by design!
#
# ---------------------------------------------------------------------------

function(ADD_WXLUABIND_GENERATION name)

    # Variables named : ${ARG_${WXLUABIND_FILES...}_VALUE} and ${..._SET}
    FUNCTION_ARG_PARSER(ARG
                        "WXLUABIND_FILES;WXLUAINTERFACE_FILES;WORKING_DIRECTORY;PROPERTIES"
                        ${ARGN})

    set(WXLUABIND_TARGET_DEPS)  # list of dependencies for the set of files

    if ("${ARG_WORKING_DIRECTORY_VALUE}" STREQUAL "")
        set(ARG_WORKING_DIRECTORY_VALUE "${CMAKE_CURRENT_SOURCE_DIR}")
    endif()

    get_filename_component(ABS_WORKING_DIRECTORY ${ARG_WORKING_DIRECTORY_VALUE} ABSOLUTE)

    file( GLOB WXLUAINTERFACE_FILES ${ARG_WXLUAINTERFACE_FILES_VALUE} ) # get the real list of files for *.lua
    set(ARG_WXLUAINTERFACE_FILES_VALUE_ABS )
    foreach(WXLUAINTERFACE_FILE ${WXLUAINTERFACE_FILES})
        if (NOT EXISTS ${WXLUAINTERFACE_FILE})
            # Try to see if it's already absolute
            get_filename_component(ABS_WXLUAINTERFACE_FILE "${ABS_WORKING_DIRECTORY}/${WXLUAINTERFACE_FILE}" ABSOLUTE)
        else()
            set(ABS_WXLUAINTERFACE_FILE "${WXLUAINTERFACE_FILE}")
        endif()
        
        set( ARG_WXLUAINTERFACE_FILES_VALUE_ABS 
             ${ARG_WXLUAINTERFACE_FILES_VALUE_ABS} 
            "${ABS_WXLUAINTERFACE_FILE}")
    endforeach()

    file( GLOB WXLUABIND_FILES ${ARG_WXLUABIND_FILES_VALUE} ) # get the real list of files for *.lua
    set( ARG_WXLUABIND_FILES_VALUE_ABS )
    
    # sort in reverse order so that they are run in the specified order
    foreach(WXLUABIND_FILE ${WXLUABIND_FILES})
        set(WXLUABIND_FILES2 ${WXLUABIND_FILE} ${WXLUABIND_FILES2})
    endforeach()
    
    foreach(WXLUABIND_FILE ${WXLUABIND_FILES2})
        if (NOT EXISTS ${WXLUABIND_FILE})
            # Try to see if it's already absolute
            get_filename_component(ABS_WXLUABIND_FILE "${ABS_WORKING_DIRECTORY}/${WXLUABIND_FILE}" ABSOLUTE)
        else()
            set(ABS_WXLUABIND_FILE "${WXLUABIND_FILE}")
        endif()

        set( ARG_WXLUABIND_FILES_VALUE_ABS
             ${ARG_WXLUABIND_FILES_VALUE_ABS} 
            "${ABS_WXLUABIND_FILE}")

        get_filename_component(WXLUABIND_FILE_WE ${WXLUABIND_FILE} NAME_WE)

        # Use deps on autogenerated dummy files for rebuilding
        set(WXLUABIND_TARGET_DUMMY "${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/wxLuaBind_${WXLUABIND_FILE_WE}.dummy")
        set(WXLUABIND_TARGET_DEPS ${WXLUABIND_TARGET_DEPS} "${WXLUABIND_TARGET_DUMMY}")

        # Initially write the dummy file so we don't try to regenerate until
        # they actually run clean first.
        file(WRITE "${WXLUABIND_TARGET_DUMMY}" 
             "Dummy build dependency file for ${ABS_WXLUABIND_FILE}")

        #@($(LUA) -e"rulesFilename=\"wxwidgets/wxadv_rules.lua\"" genwxbind.lua

        get_target_property(WXLUABIND_LUA_EXECUTABLE lua LOCATION)

        # This is the command to call protoc on each .proto file
        add_custom_command(
            OUTPUT "${WXLUABIND_TARGET_DUMMY}"
            # COMMAND ${WXLUABIND_LUA_EXECUTABLE} "-e\"rulesFileName=\\\"${ABS_WXLUABIND_FILE}\\\"\"" genwxbind.lua
            COMMAND ${WXLUABIND_LUA_EXECUTABLE} -e "rulesFilename=\"${ABS_WXLUABIND_FILE}\""  genwxbind.lua
            COMMAND echo "Dummy build dependency file for ${ABS_WXLUABIND_FILE}" > "${WXLUABIND_TARGET_DUMMY}"
            WORKING_DIRECTORY ${ARG_WORKING_DIRECTORY_VALUE}
            DEPENDS ${ABS_WXLUABIND_FILE}
            COMMENT "Running wxLua binding generator on ${WXLUABIND_FILE}"
            VERBATIM )

    endforeach()

    add_custom_target(${name} 
                      DEPENDS ${WXLUABIND_TARGET_DEPS}
                      SOURCES ${ARG_WXLUABIND_FILES_VALUE_ABS}
                              ${ARG_WXLUAINTERFACE_FILES_VALUE_ABS})
    set_target_properties(${name} PROPERTIES EXCLUDE_FROM_ALL TRUE)

    if (NOT "${ARG_PROPERTIES_VALUE}" STREQUAL "")
        SET_TARGET_PROPERTIES(${name} PROPERTIES ${ARG_PROPERTIES_VALUE} )
    endif()
endfunction()


# ---------------------------------------------------------------------------
# Create bindings for everything
# ---------------------------------------------------------------------------

ADD_WXLUABIND_GENERATION( wxluabindings 
    WXLUABIND_FILES 
        wxwidgets/wxbase_rules.lua
        wxwidgets/wxnet_rules.lua
        wxwidgets/wxcore_rules.lua
        wxwidgets/wxadv_rules.lua
        wxwidgets/wxaui_rules.lua
        wxwidgets/wxgl_rules.lua
        wxwidgets/wxhtml_rules.lua
        wxwidgets/wxmedia_rules.lua
        wxwidgets/wxpropgrid_rules.lua
        wxwidgets/wxrichtext_rules.lua
        wxwidgets/wxstc_rules.lua
        wxwidgets/wxxml_rules.lua
        wxwidgets/wxxrc_rules.lua
        wxlua/wxlua_rules.lua
        wxlua_debugger/wxluadebugger_rules.lua
        wxwidgets/wxdatatypes_rules.lua
    WXLUAINTERFACE_FILES 
        wxlua/wxlua.i
        wxlua_debugger/wxluadebugger.i
        wxwidgets/wxadv_adv.i
        wxwidgets/wxadv_grid.i
        wxwidgets/wxaui_aui.i
        wxwidgets/wxbase_base.i
        wxwidgets/wxbase_config.i
        wxwidgets/wxbase_data.i
        wxwidgets/wxbase_datetime.i
        wxwidgets/wxbase_file.i
        wxwidgets/wxcore_appframe.i
        wxwidgets/wxcore_clipdrag.i
        wxwidgets/wxcore_controls.i
        wxwidgets/wxcore_core.i
        wxwidgets/wxcore_defsutils.i
        wxwidgets/wxcore_dialogs.i
        wxwidgets/wxcore_event.i
        wxwidgets/wxcore_gdi.i
        wxwidgets/wxcore_geometry.i
        wxwidgets/wxcore_help.i
        wxwidgets/wxcore_image.i
        wxwidgets/wxcore_mdi.i
        wxwidgets/wxcore_menutool.i
        wxwidgets/wxcore_picker.i
        wxwidgets/wxcore_print.i
        wxwidgets/wxcore_sizer.i
        wxwidgets/wxcore_windows.i
        wxwidgets/wxgl_gl.i
        wxwidgets/wxhtml_html.i
        wxwidgets/wxmedia_media.i
        wxwidgets/wxnet_net.i
        wxwidgets/wxpropgrid_propgrid.i
        wxwidgets/wxrichtext_richtext.i
        wxwidgets/wxstc_stc.i
        wxwidgets/wxxml_xml.i
        wxwidgets/wxxrc_xrc.i
    WORKING_DIRECTORY "${wxLua_ROOT_DIR}/bindings" 
    PROPERTIES FOLDER "wxLua/bindings"
    )

=== wxLua/bindings/Makefile ===
# Make all the bindings in Linux or in Cygwin.

# The root wxLua directory.
WXLUA_DIR    = ../

#----------------------------------------------------------------------------

# If we're using cygwin, the lua executable maybe elsewhere, try some common places.
# Note some other variables cygwin sets don't seem to be exported.
ifeq (Cygwin, $(findstring Cygwin, $(XTERM_VERSION)))
	LUA=$(WXLUA_DIR)/bin/vc_lib/lua.exe
else
	LUA=$(WXLUA_DIR)/bin/lua
endif

LUA_ABS = $(realpath $(LUA))

#----------------------------------------------------------------------------

ALL_BINDINGS = wxbase wxcore wxadv wxaui wxgl wxhtml wxnet wxmedia wxstc wxxml wxxrc wxpropgrid wxrichtext wxwebview wxlua wxlua_debugger wxluacan wxdatatypes

# Always try to build all targets, let the other Makefiles do dep checking
.PHONY: all clean genidocs $(ALL_BINDINGS)

# These have to be in order of their dependencies
all: $(ALL_BINDINGS)

#----------------------------------------------------------------------------
# wxWidgets bindings

wxadv: wxcore
	@echo Building wxAdv
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxadv_rules.lua\"" genwxbind.lua)

wxaui: wxcore
	@echo Building wxAui
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxaui_rules.lua\"" genwxbind.lua)

wxbase:
	@echo Building wxBase
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxbase_rules.lua\"" genwxbind.lua)

wxcore: wxbase
	@echo Building wxCore
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxcore_rules.lua\"" genwxbind.lua)

wxgl: wxcore
	@echo Building wxGL
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxgl_rules.lua\"" genwxbind.lua)

wxhtml: wxcore
	@echo Building wxHtml
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxhtml_rules.lua\"" genwxbind.lua)

wxmedia: wxcore wxnet
	@echo Building wxMedia
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxmedia_rules.lua\"" genwxbind.lua)

wxnet: wxcore
	@echo Building wxNet
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxnet_rules.lua\"" genwxbind.lua)

wxpropgrid: wxcore
	@echo Building wxPropertyGrid
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxpropgrid_rules.lua\"" genwxbind.lua)

wxrichtext: wxcore
	@echo Building wxRichText
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxrichtext_rules.lua\"" genwxbind.lua)

wxstc: wxcore
	@echo Building wxStc
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxstc_rules.lua\"" genwxbind.lua)

wxwebview: wxcore
	@echo Building wxWebView
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxwebview_rules.lua\"" genwxbind.lua)

wxxml: wxbase
	@echo Building wxXml
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxxml_rules.lua\"" genwxbind.lua)

wxxrc: wxcore
	@echo Building wxXrc
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxxrc_rules.lua\"" genwxbind.lua)

# ---------------------------------------------------------------------------
# wxLua bindings

wxlua: wxbase
	@echo Building wxLua
	@($(LUA) -e"rulesFilename=\"wxlua/wxlua_rules.lua\"" genwxbind.lua)

wxlua_debugger: wxcore
	@echo Building wxLuaDebugger
	@($(LUA) -e"rulesFilename=\"wxlua_debugger/wxluadebugger_rules.lua\"" genwxbind.lua)

# ---------------------------------------------------------------------------

wxluacan: wxdatatypes
	@echo Building wxLuaCan
	@(cd $(WXLUA_DIR)/apps/wxluacan && $(MAKE) LUA=$(LUA_ABS) genwxbind)

# ---------------------------------------------------------------------------
# Generate the datatypes file that declares all the known data types.

wxdatatypes: wxadv wxaui wxbase wxcore wxgl wxhtml wxmedia wxnet wxrichtext wxstc wxxml wxxrc
	@echo Building wx DataTypes
	@($(LUA) -e"rulesFilename=\"wxwidgets/wxdatatypes_rules.lua\"" genwxbind.lua)

# ---------------------------------------------------------------------------
# make the wxluaref.htm documentation

genidocs:
	@($(LUA) -e"rulesFilename=\"genidocs_rules.lua\"" genidocs.lua)

# ---------------------------------------------------------------------------
# do nothing to clean

clean:

=== wxLua/bindings/wxlua_debugger/Makefile ===
# File:		Makefile
# Author:	John Labenski, J Winwood
# Created:	2002
# Updated:
# Copyright: (c) 2002. J Winwood

WXLUA_DIR = ../..

all: genwxbind

genwxbind:
	@(cd $(WXLUA_DIR)/bindings && ../bin/lua -e"rulesFilename=\"wxlua_debugger/wxluadebugger_rules.lua\"" genwxbind.lua)

# do nothing to clean
clean:

=== wxLua/modules/wxbind/CMakeLists.txt ===
project( wxLua_Modules_wxBind )

wxLua_Modules_wxBind_TARGETS()

=== wxLua/modules/wxlua/Makefile ===
# File:		Makefile
# Author:	John Labenski, J Winwood
# Created:	2002
# Updated:
# Copyright: (c) 2002 Lomtick Software. All rights reserved.
#
# Makefile for wxLua library using gmake

# ----------------------------------------------------------------------------
# Set path to root of wxLua
WXLUA_DIR = ../..

# ----------------------------------------------------------------------------
# Include wxLua settings using wx-config for wxWidgets parameters

include $(WXLUA_DIR)/build/Makefile_wx-config.in

# ----------------------------------------------------------------------------

WXLUA_TARGET_LIBNAME = lib$(WXLUA_LIB)

# ----------------------------------------------------------------------------

HEADERS = \
	wxldefs.h \
	wxlua.h \
	wxlbind.h \
	wxlcallb.h \
	wxlconsole.h \
	wxllua.h \
	wxlobject.h \
	wxlstate.h \
	wxlversion.h

SOURCES = \
	bit.cpp \
	lbitlib.cpp \
	wxlbind.cpp \
	wxlcallb.cpp \
	wxlconsole.cpp \
	wxllua.cpp \
	wxlobject.cpp \
	wxlstate.cpp \
	wxlua_bind.cpp

OBJECTS=$(SOURCES:.cpp=.o)
DEPFILES=$(OBJECTS:.o=.d)

# ----------------------------------------------------------------------------

.cpp.o:
	$(CXX) -c $(CXXFLAGS) $(APPEXTRADEFS) -o $@ $<

all: $(WXLUA_TARGET_LIB_STATIC) $(WXLUA_TARGET_LIB_SHARED)

clean: cleanlib

# ----------------------------------------------------------------------------
# Include wxLua targets using wx-config for wxWidgets parameters

include $(WXLUA_DIR)/build/Makefile_wx-config_targets.in

-include $(DEPFILES)

=== wxLua/modules/wxlua/debug/Makefile ===
# File:		Makefile
# Author:	John Labenski, J Winwood
# Created:	2002
# Updated:
# Copyright: (c) 2002 Lomtick Software. All rights reserved.
#
# Makefile for wxLua library using gmake

# ----------------------------------------------------------------------------
# Set path to root of wxLua
WXLUA_DIR = ../../..

# ----------------------------------------------------------------------------
# Include wxLua settings using wx-config for wxWidgets parameters

include $(WXLUA_DIR)/build/Makefile_wx-config.in

# ----------------------------------------------------------------------------

WXLUA_TARGET_LIBNAME = lib$(WXLUADEBUG_LIB)

# ----------------------------------------------------------------------------

HEADERS = \
	wxldebug.h \
	wxlstack.h

SOURCES = \
	wxldebug.cpp \
	wxlstack.cpp

OBJECTS=$(SOURCES:.cpp=.o)
DEPFILES=$(OBJECTS:.o=.d)

# ----------------------------------------------------------------------------

.cpp.o:
	$(CXX) -c $(CXXFLAGS) $(APPEXTRADEFS) -o $@ $<

all: $(WXLUA_TARGET_LIB_STATIC) $(WXLUA_TARGET_LIB_SHARED)

clean: cleanlib

# ----------------------------------------------------------------------------
# Include wxLua targets using wx-config for wxWidgets parameters

include $(WXLUA_DIR)/build/Makefile_wx-config_targets.in

-include $(DEPFILES)

=== debian/changelog ===
rehex (0.3.91-0~debian9) stretch; urgency=low

  * Fix loading of plugins bundled as part of an AppImage.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 03 May 2021 14:00:49 +0100

rehex (0.3.90-0~debian9) stretch; urgency=low

  * Show disassembly of machine code in the main document view (#94).

  * Add font size settings to "View" menu (#97).

  * Add float/double types to "Set data type" menu (#104).

  * Fix selection by holding shift and clicking (#109).

  * Initial support for Lua plugins.

  * Process sections from PE EXE/DLL headers (#86).

  * [Mark Jansen] Save size of main window and tool panels (#88).

  * Don't resize tool panels unnecessarily.

  * Fix invalid cursor state when moving between regions.

  * Fix crash when deleting data (#113, #123).

  * Fix opening files with 8-bit filenames, and other encoding issues (#117).

  * Virtual segment mapping and display (#7).

  * Display inline comments by default (didn't always work).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 02 May 2021 20:52:13 +0100

rehex (0.3.1-0~debian9) stretch; urgency=low

  * Correctly display signed 16-bit values in "Decode values" panel.

  * Fix status bar offset going out of sync.

  * Move cursor when a row in the "Comments" panel is double clicked.

  * Focus document after updating position/selection via "Comments" panel.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 13 Nov 2020 22:22:21 +0000

rehex (0.3.0-0~debian9) stretch; urgency=low

  * [Mark Jansen] Use byte grouping setting from main window in diff window.

  * [Mark Jansen] Use Capstone disassembler rather than LLVM.

  * [Mark Jansen] Support disassembling 16-bit x86 machine code.

  * [Mark Jansen] Don't update tools which aren't visible.

  * [Vincent Bermel] Unhardcode linux launcher icon file type.

  * Fix an uncommon use-after-free crash when closing tabs in diff window.

  * Support for disassembling 6800/68000 and MOS6502 instruction sets
    (requires recent Capstone version).

  * [Mark Jansen] Close document when tab is clicked with middle mouse button.

  * [Mark Jansen] Don't create .rehex-meta files when there is nothing to save.

  * Implement Strings tool to find and list ASCII strings in the file.

  * Add option to calculate automatic bytes per line in whole byte groups.

  * Add "Fill range" tool for overwriting ranges of bytes with a pattern.

  * Preserve column alignment after comments.

  * [Mark Jansen] Mark a document dirty if highlighting is changed.

  * Add data type annotations.

  * Show ranges marked as integers in their decoded form in the hex view.

  * Performance improvements for documents with large numbers of comments.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 10 Nov 2020 13:11:30 +0000

rehex (0.2.0-0~debian9) stretch; urgency=low

  * Allow copying comments from a document and pasting them elsewhere in the
    same document or into another one.

  * Fixed bounds check when clicking on nested comments in a document.

  * Added context menu when right clicking on a comment in a document.

  * Optionally highlight byte sequences which match the current selection.
    ("Highlight data matching selection" or "PatternMatchHighlight").

  * Allow copying cursor offset from document context menu.

  * Correctly display offsets over 4GiB in the status bar.

  * Display offsets as XXXX:XXXX rather than XXXXXXXX:XXXXXXXX when the file
    size is under 4GiB.

  * Add per-document option for dec/hex offset display.

  * When first byte after a comment is deleted, show that the comment was
    deleted rather than leaving phantom comment on screen until regions are
    repopulated.

  * Add side-by-side comparison of chunks of data from files. Select data and
    choose "Compare..." from context menu to open diff window.

  * Clean up search threads when a tab is closed while a search is running.

  * Display bytes which have been modified since the file was saved in red.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 02 Jun 2020 18:09:06 +0100

rehex (0.1.0-0~debian9) UNRELEASED; urgency=low

  * Initial release

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Thu, 12 Mar 2020 20:08:30 +0000

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,10 @@
  libcapstone-dev,
  debhelper (>= 9),
  libjansson-dev,
+ liblua5.3-dev,
  libwxgtk3.0-dev,
+ lua5.3,
+ pkg-config,
  xauth,
  xvfb,
  wx3.0-headers,
@@ -21,6 +24,7 @@
  ${misc:Depends},
  libcapstone3,
  libjansson4,
+ liblua5.3-0,
  libwxgtk3.0-0v5,
  zlib1g
 Description: Reverse Engineers' Hex Editor

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 # -*- makefile -*-
 
 export prefix := /usr
+export LUA := lua5.3
 
 # Snapshot builds are performed using source packages generated by git-buildpackage, which lack
 # the .git/ directory. The Buildkite job does a changelog bump using the Git commit SHA, which we
@@ -15,8 +16,16 @@
 	export GIT_COMMIT_SHA
 endif
 
+ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+	MAKE_J_FLAG = -j$(NUMJOBS)
+endif
+
+LLVM_CONFIG := llvm-config-7
+export LLVM_CONFIG
+
 %:
 	dh $@
 
 override_dh_auto_test:
-	xvfb-run -a -e /dev/stdout make check
+	xvfb-run -a -e /dev/stdout make $(MAKE_J_FLAG) check
